﻿/**
* @@@BUILDINFO@@@ xpression_v2.4.5 jsx !Version!  Zaterdag 5 januari 2013
*/
this.xp_indesignexport = {
    exportxml : function(Settings) {
        var spread = Settings[0];
        var PDFexport = Settings[1];
        var PDFpreset = Settings[2];
        var Layers = Settings[3];
       // alert(Layers);
        
//------------------------------------vanaf hier script 2.4.5------------------------------------
var start = false;
//1. Basis instellingen document definiëren
try{
myDoc = app.activeDocument;
var start= true;
}
catch(e){
    var start = false;
    alert(e);
    exit;
}


if(start==true){
//1.1.ocument uitgangspositie coordinaten instellen
app.activeWindow.transformReferencePoint = AnchorPoint.BOTTOM_LEFT_ANCHOR;
//1.1.1 document facing pages uitschakelen voor export dien aangevinkt
var myFacingpages = myDoc.documentPreferences.facingPages;

if(spread=="spread"){
myDoc.documentPreferences.facingPages=true; 
}else{
    myDoc.documentPreferences.facingPages=false; 
}
//1.2 Diverse enum waardes voor versie verschil afvangen
var fstleading ="1296852079";
var fstcapheight = "1296255087";
var fstascent = "1296135023";
var wrapnone = "1852796517";

//1.3 Begin uitlezen objecten
//alle tekstframes uitlezen
var myTextframes = myDoc.textFrames;
var myTextlen = myTextframes.length;
//alle imageframes uitlezen
var myRectangles = myDoc.rectangles;	
var myReclen = myRectangles.length;
//alle polygonen tellen
var myPolygons = myDoc.polygons;
var myPolygonsLength = myPolygons.length;
//aantal pagina's tellen
var myPages = myDoc.pages.length.toString();
var myPage = myDoc.pages;
var myPageHeight = myPage[0].bounds[2];
var myPageWidth = myPage[0].bounds[3];
//alle stijlen uitlezen
var myStyles = myDoc.allParagraphStyles;

var myCstyles = myDoc.allCharacterStyles;
//document naam uitlezen
var myName = myDoc.name.substr(0, (myDoc.name.lastIndexOf(".indd")));
//basis xml
var basisXML ='<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?><Root>';

//1.4. controleren of er labels zijn.
start = checkifsaved(myName,myDoc,true);
start = startControle();
}
//2 Begin uitlezen document indien labels aanwezig
if(start==true){
        //textframes uitlezen
        var TextFrame_array = readTextFrames();
        //Imageframes uitlezen
        var Rectangles_array = readRectangles();
        //polygons uitlezen 6.0
        var XML_polygons = readPolygons();
        //text on path uitlezen dmv textframes 6.5
       var XML_textOnPath = readTextOnPath();
       //text on path uitlezen dvm polygons 6.6
      var XML_textOnPathPoly = readTextOnPathPolygon();
        // var XML_textOnPathPoly='';
        //ovals
        //pagina structuur xml
        var XML_Pages = creatXML_Pages(myPages,myName,myPageHeight,myPageWidth);
        //characterstyles uitlezen alleen wanneer lengte > 1 (standaar is er de cstyle [none] deze niet uitlezen)
        if(myCstyles.length>1){
                var XML_cStyles = creatXML_Styles(myCstyles);
        }else{
   
              var XML_cStyles='';
         }
        //textframe xml opbouwen
        var XML_TextFrames = createXML_Fields(TextFrame_array,Rectangles_array,XML_textOnPath,XML_textOnPathPoly,XML_polygons);
        
        //xml schrijven
        Export = makeExportFile(myName,myDoc,true);
        var output = basisXML+XML_Pages+XML_cStyles+XML_TextFrames+'</Root>';
        log(Export, output);
        //Export.execute();
       
        //PDF Export indien waarde == 1
        if(PDFexport =="1"){
                   //controle of lagen uit geschakeld moeten worden
                   if(Layers!='leeg'){
                        myLayers = Layers.split(",");
                        //alert(Layers.length);
                        for(var i =0;i<myLayers.length;i++){
                                app.activeDocument.layers.item(myLayers[i]).visible = false;
                            }
                
                   }
                    var myFile = myDoc.filePath;
                    var myFile = File(myFile+ "/" + myName + ".pdf");
                    if(myFile != null){
                        app.activeDocument.exportFile(ExportFormat.PDF_TYPE, myFile, false, PDFpreset);
                    }else{
                        alert("No output file selected!");
                     }
                 
                    if(Layers!='leeg'){
                        myLayers = Layers.split(",");
                        //alert(Layers.length);
                        for(var i =0;i<myLayers.length;i++){
                                app.activeDocument.layers.item(myLayers[i]).visible = true;
                            }
                
                   }
                 
        }
        myDoc.documentPreferences.facingPages = myFacingpages;
}


//3.1functie controle of document al opgeslagen is
function checkifsaved(aName, aDoc, deleteIt) {
  var logLoc; // path to folder that will hold log file
  try {
    logLoc = aDoc.filePath;
  } catch (e) {
    //logLoc = getScriptPath().parent.fsName
    alert('document is nog niet opgeslagen.');
    exit;
  }
}


//3.2functie controle op labels
function startControle(){
var myTagCount= myDoc.xmlTags.length;
if(myTagCount<2){
alert('maak eerst de labels aan, je document bevat nog geen labels!');
var start = false;
return start;
}else{
var start = true;
return start;
}
}


//3.3  alle tekstframes doorlopen en zoeken naar gelabelde frames
function readTextFrames(){
        
         var tmparray = new Array();
 for (var i=0; myTextlen>i;i++){
   
            //  if(mytextFrames[i].textPaths.length>0){
            //alleen textframes uitlezen die XML tag hebben.
                      if(myTextframes[i].properties.associatedXMLElement !=null && myTextframes[i].textPaths.length<1){
                     //controleren of er samengestelde velden zijn
                                var items = myTextframes[i].properties.associatedXMLElement.xmlItems;
                                //controle op tekstomloop 5.7
                                var itemID = myTextframes[i].id;
                                var mywrap = checkwrap(myTextframes[i]);
                                
                                
                                
                                var sizingtype = myTextframes[i].preferences;
                               //alert(sizingtype);
                                //  alert(wrap);tFramePreference;
                                
                                if(items.length>0){ 
                                    //actie
                                      var tmparray_sveld = readChildXML(myTextframes[i]);
                                    }else{
                                      var tmparray_sveld = 'leeg';
                                   }

                                    var myCurPage="1";
                                    var myID = myTextframes[i].id;
                                    var myTagName       = myTextframes[i].properties.associatedXMLElement.markupTag.name;
                                    var myBounds          = myTextframes[i].properties.geometricBounds;
                                    var myFontname      = myTextframes[i].texts[0].appliedFont.name.toString();
                                    var myLeading         = myTextframes[i].texts[0].leading.toString();
                                    var myJustification    = myTextframes[i].texts[0].justification.toString();
                                    var myVJustification  = myTextframes[i].preferences[4].verticalJustification.toString();
                                    var myPointsize        = myTextframes[i].texts[0].pointSize.toString();
                                    var myFillColorName = myTextframes[i].texts[0].fillColor.name.toString();
                                    var myFillColor         = myTextframes[i].texts[0].fillColor.colorValue.toString();
                                    var myRotation       = myTextframes[i].rotationAngle;
                                    //object eerst rechtzetten en coordinaten uitlezen
                                    if(myRotation !=0){
                                        var myBounds = findOrgBounds(myTextframes[i],'text', myRotation);
                                    }
                                    var myFirstlinedst = myTextframes[i].textFramePreferences.firstBaselineOffset;
                                    var myFirstlinedst = convertFirstlinedst(myFirstlinedst);
                                        try{
                                            var myVllx = findAttribute("llx", myTagName);
                                            //alert(myVllx);
                                        }catch(e){
                                            var myVllx="";
                                        }
                                        try{
                                            var myVlly = findAttribute("lly", myTagName);
                                        }catch(e){
                                            var myVlly="";
                                        }
                                        try{
                                            var myVurx = findAttribute("urx", myTagName);
                                        }catch(e){
                                           var myVurx=""; 
                                        }
                                        try{
                                            var myVury = findAttribute("ury", myTagName);
                                        }catch(e){
                                            var myVury="";    
                                        }
                                        try{
                                            var myDst = findAttribute("dst", myTagName);
                                        }catch(e){
                                             var myDst="";
                                        }
                                                                    
                                    myFillColorName= checkColorNames(myFillColorName);
                                    
                                    var myTabs = myTextframes[i].texts[0].tabList;
                                    if(myTabs.length>0){
                                               //functie 5.3
                                              // alert('tabs gevonden');
                                              var myTablist = readmyTabs(myTextframes[i]);
                                              //var myTablist = writetabs(myTextframes[i]);
                                                 // myTablist=false;
                                                
;                                    }else{
                                                myTablist=false;
                                    }
                                    if(myLeading=='AUTO'){
                                                var myPointsize_nr = parseFloat(myTextframes[i].texts[0].pointSize);
                                                var myLeading = myPointsize_nr  * 1.2;
                                                var myLeading = myLeading.toString();
                                   }
                                    //bepalen welke pagina item staat alleen als meer dan 1 pagina is
                                   if(myPages>1){
                                        //functie 5.1
                                        var myCurPage = findPageNR(myID);
                                   }
                                    //xml structuur uitbreiden met attributen
                                    // updateXMLstructure(myTagName, myFontname, myPointsize, myLeading,myBounds, myJustification, myVJustification, myFillColor, myFillColorName, myCurPage);
                                    //return array
                                    
                                    if (tmparray.length>0){
                                    //tmp
                                                var myTabAlignment="";
                                                var tmparray2 = new Array(myTagName, myBounds, myCurPage, myFontname, myLeading, myPointsize,  myJustification, myVJustification, myFillColor, myFillColorName, tmparray_sveld,  myTablist , myTabAlignment, myRotation, myFirstlinedst, mywrap, myVllx, myVlly, myVurx, myVury, myDst);
                                                tmparray.push(tmparray2);
                                         
                                    }else{
                                                //tmp
                                                var myTabAlignment="";
                                                var tmparray1 = new Array(myTagName, myBounds, myCurPage, myFontname, myLeading, myPointsize, myJustification, myVJustification,  myFillColor, myFillColorName, tmparray_sveld,  myTablist , myTabAlignment, myRotation, myFirstlinedst, mywrap, myVllx, myVlly, myVurx, myVury, myDst);
                                                var tmparray = new Array(tmparray1);
                              
                                     
                               }
                           }
                      
             
                } 
            return tmparray;
  }


//3.4 alle gelabelde items binnen het textframe uitlezen
function readChildXML(myFrame){

           var tmparray_s = new Array();
           var myPrefixTxt='';
           var mySelectedStyle =" ";
                
                var items = myFrame.properties.associatedXMLElement.xmlItems;
               
                //controleren of er samengestelde velden zijn
                        if(items.length>0){  
                            
                            var paragraphs = myFrame.properties.associatedXMLElement.parentStory.paragraphs;//aantal paragrafen
                          
                          
                            for (var a=0;a<paragraphs.length;a++){
                                    //tellen hoeveel xml elements deze paragraph bevat.
                                    var ParaContent = paragraphs[a].contents.toString();//inhoud van 1 paragraaf
                                   // alert(ParaContent);
                                    var xmlItemLength = paragraphs[a].associatedXMLElements.length-1;//totaal xml items per paragraaf
                                   //alert(xmlItemLength);
                                 
                                   //controleren of er stijlen aan de paragraphs zitten
                                    var stylelist = paragraphs[a].textStyleRanges;
 
                                    if(xmlItemLength>1){
                                          //als aantal groter dan 1 is, dan is het meer dan 1 tag/veld er doorheen lopen dus
                                        for(var b=1;b<xmlItemLength+1;b++){
                                            var myTagName = paragraphs[a].associatedXMLElements[b].markupTag.name;
                                         
                                            var content = paragraphs[a].associatedXMLElements[b].contents;
                                           
                                            var ParaContent = ParaContent.replace(content,'|');
                                                
                                        }
                                        var myTMP = ParaContent.split('|');
                                        //array met alle waardes behalve de inhoud van gelabelde elementen                                   
                                      
                                            for(var b=1;b<xmlItemLength+1;b++){
                                                //if (myTMP.length>=xmlItemLength & b==xmlItemLength-1){
                                                     if (b==xmlItemLength){
                                                    
                                                        var myPostfix = myTMP[myTMP.length-1];
                                                        var myPostfix = myPostfix.toString();
                                                       // alert(myPostfix);
                                                       
                                                    }else{
                                                        var myPostfix = '';
                                                       // alert('');
                                                    }
                                               var myPrefix = myTMP[b-1];
                                          
                                              //controleren of het de eerste tag is, en de enter ervoor plaatsen 
                                              //toevoegen niet bij eeste paragraph.
                                                  if(b==1 && a!=0){
                                                  var myPrefix = 'enter'+myPrefix;
                                                  }
                                                 var myTagName = paragraphs[a].associatedXMLElements[b].markupTag.name;
                                                 
                                                  var myCname = paragraphs[a].associatedXMLElements[b].textStyleRanges[0].appliedCharacterStyle.name;
                                                  //alert(myPrefix);
                                                  var mypCname =  checkstyles(stylelist, myPrefix.replace('\t',''));
                                            
                                                 var myPrefix = myPrefix.replace('\r', '');
                                                 var myPrefix = myPrefix.replace('\t','tab');
                                                 var myPostfix = myPostfix.replace('\r', '');
                                                 
                                                 var myPrefix = myPrefix.replace('\n', '');
                                                 var myPrefix = myPrefix.replace('\t','tab');
                                                 var myPostfix = myPostfix.replace('\n', '');
                                                 
                                                 
                                                 
                                                if (tmparray_s.length>0){
                                                   
                                                    var tmparray2_s = new Array(myTagName, myPrefix, myPostfix, myCname, mypCname);
                                                    tmparray_s.push(tmparray2_s);
                                          
                                                    }else{

                                                    var tmparray1_s = new Array(myTagName, myPrefix, myPostfix, myCname, mypCname);
                                                    var tmparray_s = new Array(tmparray1_s);
                              
                                     
                                                }
                                        }
                                          
                                       
                                        
                                    }else if (xmlItemLength==1){
                                        //zoniet tekst splitsen op prefixen 
                                            //xml label ophalen
                                            var stylelist = paragraphs[a].textStyleRanges;
                                            var myTagName = paragraphs[a].associatedXMLElements[1].markupTag.name;
                                            
                                            //tekstuele inhoud van tag ophalen
                                            var content = paragraphs[a].associatedXMLElements[1].contents;
                                            var myCname = paragraphs[a].associatedXMLElements[1].textStyleRanges[0].appliedCharacterStyle.name;
                                            var mypCname ='';
                                            //volledige tekst van paragraph
                                            var ParaContent = paragraphs[a].contents.toString();
                                            //alert(ParaContent);
                                         
                                         if(a>0){
                                             
                                                var myPrefix = 'enter'+ParaContent.replace(content, '');
                                               
                                             //var myPrefix = ParaContent.replace(content, '');
                                             //controleren of er stijlen in zitten
                                            var mypCname =  checkstyles(stylelist, myPrefix);
                                          
                                          }else{
                                                var myPrefix = ParaContent.replace(content, '');
                                          }
                                                var myPrefix = myPrefix.replace('\r', '');
                                            //zoeken op spaties
                                            //zoeken op tabs
                                            if (myPrefixTxt!=''){
                                                var myPrefix = myPrefixTxt+myPrefix; 
                                            }
                                            var myPrefix = myPrefix.replace('\t','tab');
                                                var myPostfix ='';
                                            
                                           if (tmparray_s.length>0){
                                    
                                                    var tmparray2_s = new Array(myTagName, myPrefix, myPostfix, myCname, mypCname);
                                                    tmparray_s.push(tmparray2_s);
                                          
                                                    }else{
                                     
                                                    var tmparray1_s = new Array(myTagName, myPrefix, myPostfix, myCname, mypCname);
                                                    var tmparray_s = new Array(tmparray1_s);
                              
                                     
                                                }
                                       
                                           
                                    }else{
                                        //geen xmltags inhoud wel uitlezen
                                          //zoniet tekst splitsen op prefixen 
                                        
                                          // var myTagName = 'losseregel';
                                            var content = paragraphs[a].contents;
                                        
                                            var ParaContent = paragraphs[a].contents.toString();
                                            var myPrefix = 'enter'+ParaContent.replace(content, '');
                                            //zoeken op spaties
                                            //zoeken op tabs
                                            var myPrefix = myPrefix.replace('\t','tab');
                                            
                                           
                                            var myPostfix ='';
                                             
                                           var myPrefixTxt = myPrefix; 
                                           
                                        }
                                
                                }
                    }

return tmparray_s;
}

//3.5 controleren of de Colorname een pantone is of eigenstaal, indien eigenstaal colorname leeg maken, en opbouw gebruiken, tevens de standaard waardes "Black" en "Paper" afvangen
function checkColorNames(val){
    
        if(val =='Black'){
                var val ='';
        }else if(val.substr(0,1)=="C"){
                 var val='';
        }else if(val=="Paper"){
                  var val=''; 
        }else if(val.substr(0,7)!="PANTONE"){ 
                var val ='';
        }else{
                  var val = val;
        }
     
        return val
}


//4.0alle tekstframes doorlopen en zoeken naar gelabelde frames
function readRectangles(){
        var tmparray = new Array();
for (var a=0;a<myReclen;a++){
       if(myRectangles[a].properties.associatedXMLElement !=null){
             var myCurPage="1";
            var myID = myRectangles[a].id;
            var myBounds= myRectangles[a].properties.geometricBounds;
            var myFitting = myRectangles[a].frameFittingOptions.fittingOnEmptyFrame.toString();
            var myRotation = myRectangles[a].rotationAngle;
            try{
            var myMarge = myRectangles[a].textWrapPreferences.textWrapOffset[0];
            }catch(e){
                var myMarge ='';
                }
            //indien rotatie terugzetten en uitlezen.
                 if(myRotation !=0){
                                     //object eerst rechtzetten en coordinaten uitlezen
                                     //functie 5.0
                                      var myBounds = findOrgBounds(myRectangles[a],'image', myRotation);
                                      // findOrgBounds(myTextframes[i],'text', myRotation);
                    }
            
            var myTagName = myRectangles[a].properties.associatedXMLElement.markupTag.name;
          
                    if(myPages>1){
                        //functie 5.1
                        var myCurPage = findPageNR(myID);
                       }
            
                    if (tmparray.length>0){
                                    
                                        var tmparray2 = new Array(myTagName, myCurPage, myBounds, myFitting, myRotation, myMarge);
                                        tmparray.push(tmparray2);
                                          
                                    }else{
                                     
                                        var tmparray1 = new Array(myTagName, myCurPage, myBounds, myFitting, myRotation, myMarge);
                                        var tmparray = new Array(tmparray1);
                              
                                     
                               }
            
           }
    }
return tmparray;
}


//5.0 Indien textframes of imageframes zijn geroteerd deze eerst rechtzetten en dan opnieuw de coordinaten uitlezen,
function findOrgBounds(obj,type,angle){
    //
    if(type=='text'){
                    //object rechtzetten
                obj.rotationAngle =0;
                //coordinaten uitlezen
                 var myBounds= obj.properties.geometricBounds;
                // alert(myBounds[3]);
                //object terugzetten
                obj.rotationAngle =angle;
                return myBounds;
        }else if(type=="image"){
                obj.rotationAngle =0;
                //coordinaten uitlezen
                var myBounds= obj.properties.geometricBounds;
                // alert(myBounds[3]);
                //object terugzetten
               obj.rotationAngle =angle;
                return myBounds;
                
            }
}

//5.1 controlere op welke pagina het huidige object staat
function  findPageNR(myID){
            var allPages = myDoc.pages;
            for (var i=0;i<allPages.length;i++){
            //allpageitems
                var allpageItems = allPages[i].allPageItems;
                    for (var x=0;x<allpageItems.length;x++){
                            if(myID==allpageItems[x].id){
                                    var myPageNR= i+1;
                        
                                    return myPageNR;
                            }
                   }
             }

    }

//5.2 opzoeken wat het huidige paginaformaat bij geselecteerde object is, dit om de juiste coordinaten te kunnen  uitrekenen, dit wordt pas gebruikt bij het schrijven van de xml
function findPageCurrentBounds(i){
            var cPage = myDoc.pages[i-1];
            //height =2
            //width=3
     
            var mycHeight = cPage.bounds[2];
            var mycWidth = cPage.bounds[3];
            var cBounds = new Array(mycHeight, mycWidth);
        return cBounds;
    }
//5.3 tabs uitlezen van geselecteerde object
function readmyTabs(myTextframes){
    var myList = myTextframes.texts[0].tabList;
    if(myList.length>1){
            //loop door alle tabs
          for(var i=0;i<myList.length;i++){
              if(i==0){
                  var myTabPosition = myList[i].position;
                  
                    var myTabAlignment = myList[i].alignment;
                    var myTab = new Array(myTabPosition,myTabAlignment);
                    var myTabVal = new Array(myTab);
                  }else{
                var myTabPosition = myList[i].position;
                var myTabAlignment = myList[i].alignment;
                var myTab = new Array(myTabPosition,myTabAlignment);
                myTabVal.push(myTab);
                }
              }
     
           return myTabVal;
        }else{
            var myTabPosition = myList[0].position;
            var myTabAlignment = myList[0].alignment;
            var myTab = new Array(myTabPosition,myTabAlignment);
            var myTabVal = new Array(myTab);
            return myTabVal;
            }
    }


//5.4 tabs uiitschrijven
function writetabs(tablist){
  for (var i=0;i<tablist.length;i++){
        if(i==0){
                var x = tablist[i];
                var pos = x[0].toString();
            
                var a = tablist[i];
                var align = a[1].toString();
            
                var tabpos = pos;
                var tabalign = align;
          }else{
                var x = tablist[i];
                var pos = x[0].toString();
                    
                var a = tablist[i];
                var align = a[1].toString();
        
               var tabalign = tabalign+' '+align;
             var tabpos = tabpos+' '+pos;
          }
      }

      var Tabs = new Array(tabpos, tabalign);
    return Tabs;
}

//5.5 Eerste regelafstand van geselecteerde object uitlezen, dit icm  een "enum" value om versie verschillen in Indesign af te vangen.
function convertFirstlinedst(myFirstlinedst){
        if(myFirstlinedst == fstleading){
                var fdst = 'leading';
                    return fdst;
        }else if (myFirstlinedst == fstcapheight){
                var fdst = 'capheight';
                    return fdst;
        }else if (myFirstlinedst == fstascent){
                var fdst = 'ascent';
                    return fdst;
        }
}



//5.6 Controleren welke cstyle er is geselecteerd

function checkstyles(stylelist, myText){
    
    var str = myText.toString();
    //alert(str);
      for(var i=0;i<stylelist.length;i++){
              
             var text = stylelist[i].texts;
            //tekst gekoppeld aan stijl uitlezen
            var content = stylelist[i].contents.toString();
          
            //characterstyle ophalen bij item
            var cname = text[0].appliedCharacterStyle.name;
           //alert(cname);
           // \b8256 AK\b
           // var patt1="/"+content+"/g";
          eval("patt1 = /" + content + "/g");
         // var patt1 = eval('\b'+content+'\b');

        if(str.match(patt1)!=null){
            var val = cname; 
             //alert('test: '+val);
             return val
            }else{
             var val  =" ".toString() ;
        }
    
      
    }
    return val
    }

//5.7 controle op wrap

function checkwrap(myFrame){
    //alert(ID);
    var myFoundTagName=  new Array();
    for (var a=0;a<myReclen;a++){
            if(myRectangles[a].properties.associatedXMLElement !=null){
             
                //parent ID = pagina ID niet goed dus
                var myparent = myRectangles[a].id;
               // alert(myparent);
                //controle of er tekstomloop is meegegeven aan imagekader
                var myWrap = myRectangles[a].textWrapPreferences.textWrapMode;
                
               
               if(myWrap!=wrapnone){
                        //wrap gevonden coordinaten matchen obv linksboven
                        var IMGmylefttop = myRectangles[a].geometricBounds;
                        var TEXTmyBounds = myFrame.geometricBounds;
                         //ury ,urx, lly, llx
                         if(IMGmylefttop[1]<TEXTmyBounds[3] && IMGmylefttop[1] > TEXTmyBounds[1]){
                              //x coordinaat gecontroleerd en valt binnen textkader
                            
                              //y coordinaat gecontroleerd
                              if(IMGmylefttop[0] >= TEXTmyBounds[0] && IMGmylefttop[0] <= TEXTmyBounds[2]){
                                 if(myFoundTagName.length>0){
                                            
                                             myFoundTagName.push(myRectangles[a].properties.associatedXMLElement.markupTag.name);
                                             
                                           
                                 }else{
                                           var myFoundTagName = new Array(myRectangles[a].properties.associatedXMLElement.markupTag.name);
                                         
                                 }
                              }
                         
                         }
                    
                        //wrap gevonden coordinaten matchen obv rechtsonder
                        
               }
                   
            }
        }
    
    return myFoundTagName;
    
    }

//6.0 polygonen
function readPolygons(){
    
     for(i=0;i<myPolygons.length;i++){
        //door alle polygons heen lopen
        
           if(myPolygons[i].properties.associatedXMLElement !=null){
                    //alert('gevonden');
                    //ankerpunten ophalen.
                
                    var splineXML1='';
                    var mysplineName = myPolygons[i].properties.associatedXMLElement.markupTag.name;
                       
                    //eerst aantal anchors tellen
                   var lijn = myPolygons[i].paths;
                   var ankerpunten = lijn[0].pathPoints;
                    //alert(ankerpunten.length);
                    //door alle ankerpunten heen lopen
                    for (x=0;x<ankerpunten.length;x++){
                                //controle op beginpunt
                                if(x==0){
                                        var splineString='M';
                                        //begin coordinaten
                                        
                                        var ankerX = parseFloat(ankerpunten[x].anchor[0]).toFixed(2)
                                        var ankerY = parseFloat(ankerpunten[x].anchor[1]).toFixed(2)
                                        //coordinaten handle beginpunt
                                       
                                        var rightX =  parseFloat(ankerpunten[x].rightDirection[0]).toFixed(2);
                                        var rightY =  parseFloat(ankerpunten[x].rightDirection[1]).toFixed(2);
                                                                                                                
                                        var left2X = parseFloat(ankerpunten[x+1].rightDirection[0]).toFixed(2);
                                        var left2Y = parseFloat(ankerpunten[x+1].rightDirection[1]).toFixed(2);
                                        
                                       // splineString = splineString + " " + ankerX + " " + ankerY + " C " + rightX + " " + rightY + " " + left2X + " " + left2Y; 
                                        splineString = splineString + " " + ankerX + " " + ankerY + " C " + rightX + " " + rightY + " " + left2X + " " + left2Y; 
                                        
                                    }else if(x<ankerpunten.length && x!=ankerpunten.length-1){
                                    
                                        //begin coordinaten
                                        var ankerX = parseFloat(ankerpunten[x].anchor[0]).toFixed(2);
                                        var ankerY = parseFloat(ankerpunten[x].anchor[1]).toFixed(2);
                                        
                                        var leftX = parseFloat(ankerpunten[x].rightDirection[0]).toFixed(2);
                                        var leftY = parseFloat(ankerpunten[x].rightDirection[1]).toFixed(2);
                                        
                                                                          
                                        var right2X = parseFloat(ankerpunten[x+1].rightDirection[0]).toFixed(2);
                                        var right2Y = parseFloat(ankerpunten[x+1].rightDirection[1]).toFixed(2);
                                                                             
                                        
                                        splineString = splineString + " " + ankerX + " " + ankerY + " C " + leftX + " " + leftY  + " " + right2X + " " + right2Y;
                                        
                                       }else if(x==ankerpunten.length-1){

                                        var ankerX = parseFloat(ankerpunten[x].anchor[0]).toFixed(2);
                                        var ankerY = parseFloat(ankerpunten[x].anchor[1]).toFixed(2);   
                                        
                                        var leftX = parseFloat(ankerpunten[x].rightDirection[0]).toFixed(2);
                                        var leftY = parseFloat(ankerpunten[x].rightDirection[1]).toFixed(2);
                                        
                                                                          
                                        var right2X = parseFloat(ankerpunten[0].rightDirection[0]).toFixed(2);
                                        var right2Y = parseFloat(ankerpunten[0].rightDirection[1]).toFixed(2);
                                                                             
                                        
                                        splineString = splineString + " " + ankerX + " " + ankerY + " C " + leftX + " " + leftY  + " " + right2X + " " + right2Y;
                                    }
                                       
                 
                        }
                                        var ankerX = parseFloat(ankerpunten[0].anchor[0]).toFixed(2);
                                        var ankerY = parseFloat(ankerpunten[0].anchor[1]).toFixed(2);   
                                        
                                        splineString = splineString + " " + ankerX+ " " + ankerY
                                       
                //coordinaten uitlezen
                var myBounds = myPolygons[i].properties.geometricBounds;
                var myID = myPolygons[i].id;
                var myCurPage = findPageNR(myID);
                var myPageBounds = findPageCurrentBounds(myCurPage);  
                //ury urx lly llx
                //((myPageBounds[0]-myBounds[0]).toString())
             
                 var splineXML='<field ury=\"'+((myPageBounds[0]-myBounds[0]).toString())+'\" urx=\"'+myBounds[1]+'\" lly=\"'+((myPageBounds[0]-myBounds[2]).toString())+'\" llx=\"'+myBounds[3]+'\" page="1" type="image" name=\"'+mysplineName+'\" svg=\"'+splineString+'\"></field>';
           
             
                return splineXML;
               }
        }
}


//6.5 text on Path uitlezen
function readTextOnPath(){
    var splineXML='';
   // alert('start');
for (var i = 0; i<myTextframes.length;i++){
    
        if(myTextframes[i].properties.associatedXMLElement !=null){
             
             if(myTextframes[i].textPaths.length>0){
                 //alert("tekst op path gevonden");
                 var splineXML1='';
                 
                 var mysplineName = myTextframes[i].properties.associatedXMLElement.markupTag.name;
                //alert(mysplineName);
                 var lijn = myTextframes[i].paths;
                 var ankerpunten = lijn[0].pathPoints;
                 var myFontname      = myTextframes[i].texts[0].appliedFont.name.toString();
                 var myLeading         = myTextframes[i].texts[0].leading.toString();
                 var myJustification    = myTextframes[i].texts[0].justification.toString();
                 var myPointsize        = myTextframes[i].texts[0].pointSize.toString();
                 var myFillColorName = myTextframes[i].texts[0].fillColor.name.toString();
                 var myFillColor         = myTextframes[i].texts[0].fillColor.colorValue.toString();

                 myFillColorName= checkColorNames(myFillColorName);
                 
                 
                   for (x=0;x<ankerpunten.length;x++){
                                //controle op beginpunt
                                if(x==0){
                                        var splineString='M';
                                        //begin coordinaten
                                        var ankerX = ankerpunten[x].anchor[0];
                                        var ankerY = ankerpunten[x].anchor[1];
                                        //coordinaten handle beginpunt
                                        var rightX = ankerpunten[x].rightDirection[0];
                                        var rightY = ankerpunten[x].rightDirection[1];
                                        
                                        var left2X = ankerpunten[x+1].leftDirection[0];
                                        var left2Y = ankerpunten[x+1].leftDirection[1];
                                        
                                        splineString = splineString + " " + ankerX + " " + ankerY + " C " + rightX + " " + rightY + " " + left2X + " " + left2Y; 
                                        
                                    }else if(x<ankerpunten.length && x!=ankerpunten.length-1){
                                        //begin coordinaten
                                        var ankerX = ankerpunten[x].anchor[0];
                                        var ankerY = ankerpunten[x].anchor[1];   
                                        
                                        var rightX = ankerpunten[x].rightDirection[0];
                                        var rightY = ankerpunten[x].rightDirection[1];
                                        
                                        var left2X = ankerpunten[x+1].leftDirection[0];
                                        var left2Y = ankerpunten[x+1].leftDirection[1];
                                                                             
                                        
                                        splineString = splineString + " " + ankerX + " " + ankerY + " C " + rightX + " " + rightY  + " " + left2X + " " + left2Y;
                                    }else{
                                        
                                        var ankerX = ankerpunten[x].anchor[0];
                                        var ankerY = ankerpunten[x].anchor[1];   
                                        
                                        splineString = splineString + " " + ankerX+ " " + ankerY
                                        }
                               
                 
                        }
                    
                 var splineXML1='<field name=\"'+mysplineName+'\" fontname=\"'+myFontname+'\" justification=\"'+myJustification+'\" leading=\"'+myLeading+'\" poinsize=\"'+myPointsize+'\" fillcolor=\"'+myFillColor  +'\" fillcolorname=\"'+myFillColorName+'\" svg=\"'+splineString+'\"></field>';
                 splineXML= splineXML+splineXML1;
            
            
                 
                 }
            
            }
        
    }

return splineXML;
 }


//6.6 text on Path dmv polygon
function readTextOnPathPolygon(){
    var splineXML='';
   // alert('start');
for (var i = 0; i<myPolygons.length;i++){
    
        if(myPolygons[i].properties.associatedXMLElement !=null){
             
             if(myPolygons[i].textPaths.length>0){
                 //alert("tekst op path gevonden");
                 var splineXML1='';
                 
                 var mysplineName = myPolygons[i].properties.associatedXMLElement.markupTag.name;
                 //alert(mysplineName);
                 var lijn = myTextframes[i].paths;
                 var ankerpunten = lijn[0].pathPoints;
                 var myFontname      = myPolygons[i].textPaths[0].texts[0].appliedFont.name.toString();
                 var myLeading         = myPolygons[i].textPaths[0].texts[0].leading.toString();
                 var myJustification    = myPolygons[i].textPaths[0].texts[0].justification.toString();
                 var myPointsize        = myPolygons[i].textPaths[0].texts[0].pointSize.toString();
                 var myFillColorName = myPolygons[i].textPaths[0].texts[0].fillColor.name.toString();
                 var myFillColor         = myPolygons[i].textPaths[0].texts[0].fillColor.colorValue.toString();

                 myFillColorName= checkColorNames(myFillColorName);
                 
                 
                   for (x=0;x<ankerpunten.length;x++){
                                //controle op beginpunt
                                if(x==0){
                                        var splineString='M';
                                        //begin coordinaten
                                        var ankerX = ankerpunten[x].anchor[0];
                                        var ankerY = ankerpunten[x].anchor[1];
                                        //coordinaten handle beginpunt
                                        var rightX = ankerpunten[x].rightDirection[0];
                                        var rightY = ankerpunten[x].rightDirection[1];
                                        
                                        var left2X = ankerpunten[x+1].leftDirection[0];
                                        var left2Y = ankerpunten[x+1].leftDirection[1];
                                        
                                        splineString = splineString + " " + ankerX + " " + ankerY + " C " + rightX + " " + rightY + " " + left2X + " " + left2Y; 
                                        
                                    }else if(x<ankerpunten.length && x!=ankerpunten.length-1){
                                        //begin coordinaten
                                        var ankerX = ankerpunten[x].anchor[0];
                                        var ankerY = ankerpunten[x].anchor[1];   
                                        
                                        var rightX = ankerpunten[x].rightDirection[0];
                                        var rightY = ankerpunten[x].rightDirection[1];
                                        
                                        var left2X = ankerpunten[x+1].leftDirection[0];
                                        var left2Y = ankerpunten[x+1].leftDirection[1];
                                                                             
                                        
                                        splineString = splineString + " " + ankerX + " " + ankerY + " " + rightX + " " + rightY  + " " + left2X + " " + left2Y;
                                    }else{
                                        
                                        var ankerX = ankerpunten[x].anchor[0];
                                        var ankerY = ankerpunten[x].anchor[1];   
                                        
                                        splineString = splineString + " " + ankerX+ " " + ankerY
                                        }
                               
                 
                        }
                    
                 var splineXML1='<field name=\"'+mysplineName+'\" fontname=\"'+myFontname+'\" justification=\"'+myJustification+'\" leading=\"'+myLeading+'\" poinsize=\"'+myPointsize+'\" fillcolor=\"'+myFillColor  +'\" fillcolorname=\"'+myFillColorName+'\" svg=\"'+splineString+'\"></field>';
                 splineXML= splineXML+splineXML1;
            
            
                 
                 }
            
            }
        
    }

return splineXML;
 }

//6.7 attributen opzoeken
function findAttribute(name,tagname){
      //  alert(name);
        //door alle textframes heen lopen
        for(var i=0;i<myTextframes.length;i++){
            //juiste tagname opzoeken
            if(myTextframes[i].properties.associatedXMLElement.markupTag.name == tagname){
                   //-----
                    for(var x=0;x<myTextframes[i].properties.associatedXMLElement.xmlAttributes.length;x++){
                        
                            var myName= myTextframes[i].properties.associatedXMLElement.xmlAttributes[x].name;
                            //juiste attribute opzoeken
                            if(myName==name){
                               // alert('attribuut gevonden');
                                var myValue = myTextframes[i].properties.associatedXMLElement.xmlAttributes[x].value;
                                
                            }
                    }
                  //---
               }
            
            }
      //  alert(myValue);
         if(myValue.toString()=="undefined"){
            myValue="";
            }
        return myValue;
    
    }
//6.8 custom propertie string opbouwen
function createProp(type,tagname,dst,myPageBounds){
        //tagname splitsen 
        var tag= tagname.split("_");
        searchtag= tag[0];
       if(type=="text"){
        //door alle textframes heen lopen
        for(var i=0;i<myTextframes.length;i++){
            //juiste tagname opzoeken
            if(myTextframes[i].properties.associatedXMLElement.markupTag.name == searchtag){
                   //-----
                 
                    var myBounds = myTextframes[i].properties.geometricBounds;
                    if(tag[1]=="lly"){
                            var start = (myPageBounds[0]-myBounds[0]).toString();
                            var output = "["+start+","+tagname+"-"+dst+"].min";
                     }else if(tag[1]=="urx"){
                            var start = (myPageBounds[0]-myBounds[3]).toString();
                            var output = "["+start+","+tagname+"-"+dst+"].min";
                         }

                  //---
               }
            
            }
           }else if(type=="image"){
           
           }
        
         //alert(output);
        return output;
    
    }

//7.0 pagina xml opbouwen
function creatXML_Pages(myPages,myName,myPageHeight, myPageWidth){
      var pageXML ='<pages><page pageid=\"'+myPages+'\" name=\"'+myName+'\" height=\"'+myPageHeight.toString()+'\" width=\"'+myPageWidth.toString()+'\"></page></pages>';
        
      return pageXML;
}
//7.1 characterstyle xml opbouwen
function creatXML_Styles(myCstyles){
    var styleXMLtmp='';
    
    for(i=0;i<myCstyles.length;i++){
            
            var cname = myCstyles[i].name;
            //alert(cname);
            //cname!="[Geen]"
            if(cname!="[None]") {
                if(cname!="[Geen]"){
         
                var cname = myCstyles[i].name;
                var cfontname = myCstyles[i].appliedFont;
                var cfontstyle = myCstyles[i].fontStyle;
                var cfontsize = myCstyles[i].pointSize.toString();
                var cleading = myCstyles[i].leading.toString();
                    if(cfontname=="NOTHING"){ cfontname='';}
                    if(cfontsize=="NOTHING"){ cfontsize='';}    
                    if(cleading=="NOTHING"){ cleading='';}
                        
                    
                
                var err ='';
                try{
                            var cFillcolor = myCstyles[i].fillColor.colorValue.toString();
                    }catch(err){
                            var cFillcolor ='';
                    }
                //var cFillcolorname= myCstyles[i].fillColor.name.toString();
                var cFillcolorname ='';
               // var cFillcolorname =  checkColorNames(myCstyles[i].fillColor.name.toString());
                var cSpacing = myCstyles[i].tracking.toString();
                 if(cSpacing=="NOTHING"){ cSpacing='';}
                   //alert(myCstyles[i].name);
                var styleXMLtmp  = styleXMLtmp+'<cstyle type=\"character\" name=\"'+cname+'\" fontname=\"'+cfontname+' '+cfontstyle+'\"  leading=\"'+cleading+'\" spacing=\"'+cSpacing+'\" fillcolor=\"'+cFillcolor+'\"  fillcolorname=\"'+cFillcolorname+'\"></cstyle>';
            }
            }
    }
    var styleXML = '<styles>'+styleXMLtmp+'</styles>';
    return styleXML;
}

//8,0 xml opbouwen
function createXML_Fields(TextFrame_array, Rectangles_array, TextOnPath, TextOnPathPoly,XML_polygons){

var fieldXML='<fields>';
var fieldXML1='';
var fieldXML2='';

for (var a=0;a<TextFrame_array.length;a++){

    var frameprops = TextFrame_array[a];
    var fieldXML1a='';

            var Bounds = frameprops[1].toString();
            Bounds = Bounds.split(',');
            
                //create tab values
                if(frameprops[11]!=false){
              var Tabs = writetabs(frameprops[11]);
                }else{
                    var Tabs=new Array('','');
                    }
            //zoek pagina afmeting
            //paginanummer = frameprops[2];
              var myPageBounds = findPageCurrentBounds(frameprops[2]);  
                            
              var myWrap = frameprops[15].toString();
              myWrap = myWrap.replace(',' , ' ');
              
              //verschuiving
              //frameprops[19] = ury
              
              if(frameprops[19]!=""){
                var vury = createProp("text",frameprops[19],frameprops[20],myPageBounds);
                alert(vury);
              }else{
                  vury="";
                  }
                
            var  fieldXML1=fieldXML1+'<field  name=\"'+frameprops[0]+'\" type=\"textflow\" page=\"'+frameprops[2]+'\" fontname=\"'+frameprops[3]+'\" leading=\"'+frameprops[4]+'\" pointsize=\"'+frameprops[5]+'\"  justification=\"'+frameprops[6]+'\" vjustification=\"'+frameprops[7]+'\" fillcolor=\"'+frameprops[8]+'\" fillcolorname=\"'+frameprops[9]+'\" tabpositie=\"'+Tabs[0]+'\" tabalignment=\"'+Tabs[1]+'\"  ury=\"'+((myPageBounds[0]-Bounds[0]).toString())+'\" urx=\"'+Bounds[3]+'\" lly=\"'+((myPageBounds[0]-Bounds[2]).toString())+'\" llx=\"'+Bounds[1]+'\" rotation=\"'+frameprops[13]+'\" firstlinedst=\"'+frameprops[14]+'\" wrap=\"'+myWrap+'\" vllx=\"'+frameprops[16]+'\"  vlly=\"'+frameprops[17]+'\" vurx=\"'+frameprops[18]+'\" vury=\"'+frameprops[19]+'\" dst=\"'+frameprops[20]+'\">';
         
         if(frameprops[10]!='leeg'){
             var frameprops_s = frameprops[10];    
             
            for (g=0;g<frameprops_s.length;g++){
                        var items_s = frameprops_s[g];
                        var myPrefix = escape(items_s[1]);
                         var myPrefix = myPrefix.replace(/%uFEFF/g,'');
                        
                        var myPostfix = escape(items_s[2]);
                        var myPostfix = myPostfix.replace(/%uFEFF/g,'');
                     
                       var myPrefix = unescape(myPrefix);
                       var myPostfix = unescape(myPostfix);
                       
                       var myCStyle = items_s[3];
                       if(myCStyle==undefined){
                           myCStyle = "";
                           }
                       
                       var mypCstyle = items_s[4];
                       if(mypCstyle ==undefined){
                           mypCstyle ="";
                           }
                
                       var fieldXML1a =fieldXML1a+'<field name=\"'+items_s[0]+'\" type=\"textflow\" prefix=\"'+myPrefix+'\" postfix=\"'+myPostfix+'\" cstyle=\"'+myCStyle+'\" pcstyle=\"'+mypCstyle+'\"></field>';
                
                
                 }
          }
          var fieldXML1=fieldXML1+fieldXML1a+'</field>';
          
}

for (var b=0;b<Rectangles_array.length;b++){
     
     var frameprops = Rectangles_array[b];
     var Bounds = frameprops[2].toString();
     Bounds = Bounds.split(',');
     
       //zoek pagina afmeting
       //paginanummer = frameprops[2];
       var myPageBounds = findPageCurrentBounds(frameprops[1]);  
       //myPageBounds[0]= height;
       //m,yPageBounds[1]=width;
            
            
            
     var fieldXML2 = fieldXML2+'<field rotation=\"'+frameprops[4]+'\" name=\"'+frameprops[0]+'\" type=\"image\" page=\"'+frameprops[1]+'\" fitmethod=\"'+frameprops[3]+'\" ury=\"'+((myPageBounds[0]-Bounds[0]).toString())+'\" urx=\"'+Bounds[3]+'\" lly=\"'+((myPageBounds[0]-Bounds[2]).toString())+'\" llx=\"'+Bounds[1]+'\" marge=\"'+frameprops[5]+'\"></field>';
}






var fieldXML= '<fields>'+fieldXML1+fieldXML2+TextOnPath+TextOnPathPoly+XML_polygons+'</fields>';
return fieldXML;
}

//9.0 schrijf xml
function makeExportFile(aName, aDoc, deleteIt) {
  var logLoc; // path to folder that will hold log file
  try {
    logLoc = aDoc.filePath;
  } catch (e) {
    //logLoc = getScriptPath().parent.fsName
    alert('document is nog niet opgeslagen.');
    exit;
  }
  var aFile = File(logLoc + "/" + aName + ".xml");
  if (deleteIt) {
    aFile.remove();
    return aFile;
  }
  var n = 1;
  while (aFile.exists) {
    aFile = File(logLoc + "/" + aName + String(n) + ".xml");
    n++
  }
    aFile.encoding="UTF-16";
    
  return aFile
}
function log(aFile, message) {
 
  if (aFile.exists) {
        aFile.open("e");
        aFile.seek(0, 2);
    }
    else {
        aFile.open("w");
    }
    aFile.write(message); 
    aFile.close();
   
}

//-------------------------------------------------------------------------------------------------        
        }
    };